config/routes.rb
Rails.application.routes.draw do
  root 'home#index'

  get "home/:id", to: "home#show", as: "show"

  devise_for :users
  resources :items, :carts, :charges

  post '/:id/item/:item', to: 'carts#add_item', as: 'add_item'
  post '/:id', to: 'carts#destroy_item', as: 'destroy_item'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cart.rb
class Cart < ApplicationRecord
  belongs_to :user
  has_and_belongs_to_many :items
end

app/models/item.rb
class Item < ApplicationRecord
  has_and_belongs_to_many :carts
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/carts_controller.rb
class CartsController < ApplicationController
  before_action :set_cart, only: [:edit, :update, :destroy, :destroy_item]
  before_action :check_user, only: [:show]

  # GET /carts
  # GET /carts.json
  def index
    @carts = Cart.all
  end

  # GET /carts/1
  # GET /carts/1.json
  def show
  	
  end

  # GET /carts/new
  def new
    @cart = Cart.new
  end

  # GET /carts/1/edit
  def edit
  end

  # POST /carts
  # POST /carts.json
  def create
    @cart = Cart.new(cart_params)

    respond_to do |format|
      if @cart.save
        format.html { redirect_to @cart, notice: 'cart was successfully created.' }
        format.json { render :show, status: :created, location: @cart }
      else
        format.html { render :new }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /carts/1
  # PATCH/PUT /carts/1.json
  def update
    respond_to do |format|
      if @cart.update(cart_params)
        format.html { redirect_to @cart, notice: 'cart was successfully updated.' }
        format.json { render :show, status: :ok, location: @cart }
      else
        format.html { render :edit }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /carts/1
  # DELETE /carts/1.json
  def destroy
    @cart.destroy
    respond_to do |format|
      format.html { redirect_to carts_url, notice: 'cart was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def add_item
    Cart.find(params[:id]).items << Item.find(params[:item])
  end

  def destroy_item
    item = Item.find(params[:item])
    cart = item.carts.find(@cart.id)
    item.carts.delete(cart)
    redirect_to cart_path(@cart.id)
  end

  def create
    # Amount in cents
    @amount = @price

    customer = Stripe::Customer.create(
      :email => params[:stripeEmail],
      :source  => params[:stripeToken]
    )

    charge = Stripe::Charge.create(
      :customer    => customer.id,
      :amount      => @amount,
      :description => 'Rails Stripe customer',
      :currency    => 'usd'
    )

  rescue Stripe::CardError => e
    flash[:error] = e.message
    redirect_to new_charge_path
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cart
      @cart = Cart.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cart_params
      params.fetch(:cart, {})
    end

    def check_user
      @cart = Cart.find(params[:id])
      redirect_to root_path unless current_user == @cart.user
      @price = 0
      @cart.items.each { |item| @price += item.price }
    end
end

app/controllers/charges_controller.rb
class ChargesController < ApplicationController
	def new
	end

	def create
	  cart = Cart.find_by(user_id: current_user.id)
	  Item.all.each do |item|
        item.carts.delete(cart)
      end
	end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  before_action :find_cat, only:[:show]
  before_action :set_cats
  def index
    @cats = Item.all
    @check = 0;
    Cart.all.each do |cart|
      if cart.user == current_user
        @check = 1
        @cart = cart
        break
      end
    end
    if @check == 0
      @cart = Cart.new
      @cart.user = current_user
      @cart.save
    end
  end

  def show
  end

  private
  def set_cats
    @cats = Item.all
  end

  def find_cat
    @cat = Item.find(params[:id])
  end
end

app/controllers/items_controller.rb
class ItemsController < ApplicationController
  before_action :set_item, only: [:show, :edit, :update, :destroy]

  # GET /items
  # GET /items.json
  def index
    @items = Item.all
  end

  # GET /items/1
  # GET /items/1.json
  def show
    @items = Item.all
    @check = 0;
    Cart.all.each do |cart|
      if cart.user == current_user
        @check = 1
        @cart = cart
        break
      end
    end
    if @check == 0
      @cart = Cart.new
      @cart.user = current_user
      @cart.save
    end
  end

  # GET /items/new
  def new
    @item = Item.new
  end

  # GET /items/1/edit
  def edit
  end

  # POST /items
  # POST /items.json
  def create
    @item = Item.new(item_params)

    respond_to do |format|
      if @item.save
        format.html { redirect_to @item, notice: 'Item was successfully created.' }
        format.json { render :show, status: :created, location: @item }
      else
        format.html { render :new }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /items/1
  # PATCH/PUT /items/1.json
  def update
    respond_to do |format|
      if @item.update(item_params)
        format.html { redirect_to @item, notice: 'Item was successfully updated.' }
        format.json { render :show, status: :ok, location: @item }
      else
        format.html { render :edit }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /items/1
  # DELETE /items/1.json
  def destroy
    @item.destroy
    respond_to do |format|
      format.html { redirect_to items_url, notice: 'Item was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_item
      @item = Item.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def item_params
      params.fetch(:item, {})
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/carts_helper.rb
module CartsHelper
end

app/helpers/charges_helper.rb
module ChargesHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/items_helper.rb
module ItemsHelper
end

app/views/carts/show.html.erb
<div id="customcarts">
  <h1>😺</h1>
  <h1>My cat carts: <%= @cart.id %></h1>
  <% @cart.items.each do |item| %>
  <div class="photos">
    <p> La superbe photo faite par: <%= item.title %></p>
    <%= image_tag(item.image_url) %>
    <p><%= button_to "Destroy", action: 'destroy_item', id: @cart.id, item: item.id %></p>
  </div>
  <% end %>
  <div class="totalprice">
    <p>Prix total</p>
    <h2><%= @price %></h2>
  </div>
  <div class="footer">
  </div>
</div>
  <div id="customstripe">
<%= form_tag charges_path do %>
  <article>
    <% if flash[:error].present? %>
      <div id="error_explanation">
        <p><%= flash[:error] %></p>
      </div>
    <% end %>
    <label class="amount">
      <span>Amount: <%= @price %> €</span>
    </label>
  </article>


  <script src="https://checkout.stripe.com/checkout.js" class="stripe-button"
          data-key="<%= Rails.configuration.stripe[:publishable_key] %>"
          data-description="A month's subscription"
          data-currency="eur"
          data-amount="<%= @price * 100 %>"
          data-locale="auto"></script>
            </div>
<% end %>

app/views/charges/create.html.erb
<div id="customstripe">
  <h1>Thank you</h1>
  <%= image_tag ("http://gif-finder.com/wp-content/uploads/2015/07/Shia-LaBeouf-Clapping.gif") %>
</div>
<div class="customstripe">
  <p>Vous venez de payez pour des images de chat !</p>
</div>

app/views/home/index.html.erb
<div class="header">
  <div class="filter">
    <div class="section">
      <h1>The coolest cat from the net</h1>
      <p>Get your pictures right now!</p>
    </div>
  </div>
</div>

<div class="content">
    <% @cats.each do |cat| %>
    <div class="main">
      <a href="items/<%= cat.id %>">
     <%= image_tag(cat.image_url) %>
      <h3><%= cat.title %></h3>
      <br><hr>
      <h1><%= cat.price %>€</h1>
      <p><%= cat.description %></p>
      </a>
    </div>
      <% end %>
</div>

app/views/home/show.html.erb
<div class="show">
  <h1>Get your kitten's picture!</h1>
  <p>get it right now!!!</p>
</div>

<div class="container">
  <div class="article">
    <%= image_tag(@cat.image_url) %>
  </div>
  <div class="description">
    <div class="details">
      <h2><%= @cat.title %></h2>
      <br><hr>
      <p><%= @cat.description %></p>
      <h1><%= @cat.price %>€</h1>
    </div>
  </div>
</div>
<div class="button">
  <%= link_to "Add to cart", root_path %>
</div>
<div class="section1">
  <h1>Jamais deux sans trois!😸</h1>
</div>

<div class="content">

    <% @cats.each do |cat| %>
    <div class="main">
      <%= image_tag(cat.image_url) %>
      <h3><%= cat.title %></h3>
      <p><%= cat.description %></p>
      <p><%= cat.price %></p>
    </div>
      <% end %>
</div>

app/views/items/_form.html.erb
<%= form_with(model: item, local: true) do |form| %>
  <% if item.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(item.errors.count, "error") %> prohibited this item from being saved:</h2>

      <ul>
      <% item.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/items/edit.html.erb
<h1>Editing Item</h1>

<%= render 'form', item: @item %>

<%= link_to 'Show', @item %> |
<%= link_to 'Back', items_path %>

app/views/items/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Items</h1>

<table>
  <thead>
    <tr>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @items.each do |item| %>
      <tr>
        <td><%= link_to 'Show', item %></td>
        <td><%= link_to 'Edit', edit_item_path(item) %></td>
        <td><%= link_to 'Destroy', item, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Item', new_item_path %>

app/views/items/new.html.erb
<h1>New Item</h1>

<%= render 'form', item: @item %>

<%= link_to 'Back', items_path %>

app/views/items/show.html.erb
<div class="show">
  <h1>Get your kitten's picture!</h1>
  <p>get it right now!!!</p>
</div>

<div class="container">
  <div class="article">
    <%= image_tag(@item.image_url) %>
  </div>
  <div class="description">
    <div class="details">
      <h2><%= @item.title %></h2>
      <br><hr>
      <p><%= @item.description %></p>
      <h1><%= @item.price %>€</h1>
    </div>
  </div>
</div>
<div class="button">
  <p><%= button_to "Add to cart", add_item_path(@cart.id,@item.id) %></p>
</div>
<div class="section1">
  <h1>Jamais deux sans trois!😸</h1>
</div>

<div class="content">
    <% @items.each do |item| %>
	    <% unless item.id == @item.id %>
		    <div class="main">
		      <a href="<%= item.id %>">
			      <%= image_tag(item.image_url) %>
			      <h3><%= item.title %></h3>
			      <p><%= item.description %></p>
			      <p><%= item.price %></p>
			  </a>
		    </div>
		<% end %>
  <% end %>
</div>

app/views/layouts/_footer.html.erb
<footer>
  <h1>😹😸😺</h1><br/>
  <hr>
  <p>thats the best footer ever - copy right 2018</p>
</footer>

app/views/layouts/_header.html.erb
<div class="nav">
<a href="/"><%= image_tag ("https://assets-cdn.github.com/images/modules/logos_page/GitHub-Mark.png") %></a>
  <% if user_signed_in? %>
    <% unless @cart.nil? %>
      <%= link_to cart_path(@cart) do %>
        <%= image_tag 'panier.png', class: 'stylay' %>
      <% end %>
    <% end %>
    <div class="login">
      <%= link_to "Edit", edit_user_registration_path %>
      <%= link_to "Sign Out", destroy_user_session_path, method: :delete %>
    </div>
  <% else %>
    <div class="login">
      <%= link_to "Connexion", new_user_session_path %>
      <%= link_to "Sign Up", new_user_registration_path %>
    </div>
  <% end %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Peak a cat</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://fonts.googleapis.com/css?family=Josefin+Sans" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=Indie+Flower" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=Pacifico" rel="stylesheet">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/header' %>


    <%= yield %>

    <%= render 'layouts/footer' %>
  </body>
</html>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>